/*
Copyright (C) 2009 -  Claudio Salvadori 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef CXOR_H
#define CXOR_H

#include <string.h>
#include <vector>

#include "IDecoderDaq.h"

/**
 *\file CXor.h
 *\date  Created on: 26-apr-2009
 *\author  Author: Claudio Salvadori
 *\brief Implementation of IDecoderDaq interface to decode the escape
 *	character with xor function
 */

 /**
 *\class CXor
 *\brief Implementation of IDecoderDaq interface to decode the escape
 *	character with xor function
 */
class CXor: implements IDecoderDaq{
	public:
		/**\brief Initialize the stream decoder
		*\param def 	Pointer to a stream definition structure (input)
		*\return This method return one of the possible value from s_ret \see s_ret*/
		virtual s_ret getDefinition (struct SDef def);
		
		/**\brief Method that return the decoded packet 
		*\param buffer_i	Pointer of the buffet to decode (input)
		*\param length_i	Length of the buffer to decode (input)
		*\param buffer_o 	Pointer to a pointer of a vector of byte to be formatted (output)
		*\param length_o 	Pointer to the packet lenght variable (output)
		*\return This method return one of the possible value from s_ret \see s_ret*/
		virtual s_ret retStream(unsigned char *buffer_i, unsigned long length_i, unsigned char **buffer_o, unsigned long *length_o);
		
	private:
		unsigned char			xor_Esc;	/**< Escape character */
};
#endif
