/*
Copyright (C) 2009 -  Claudio Salvadori
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/**
 *\file fdy.cpp
 *\brief  Vision algorithms development functions
 */
#include <string.h>
#include "fdy.h"

#define GRAY_LEVEL 256

unsigned int h_old[GRAY_LEVEL]; 	/* Previous picture histogram buffer*/
unsigned int h_act[GRAY_LEVEL];		/* Actual picture histogram buffer*/

unsigned long sum;

//Function definition
void create_histogram(unsigned char*, long unsigned int);
int minimum(unsigned int a, unsigned int b);

//Fdy function
float fdy_cd(unsigned char *image, unsigned long size){

	unsigned int i = 0;

	//unsigned long sum = 0;
	sum = 0;
	if(image == NULL)
		return 0;

	create_histogram(image, size);

	for(i = 0; i < GRAY_LEVEL; i++){
		sum += minimum(h_old[i], h_act[i]);

		//save the actual histogram in the old histogram buffer
		h_old[i] = h_act[i];

		h_act[i] = 0;
	}

	return ((float) (sum * 100)) / size;
}

//Create the histogram for the actual image
void create_histogram(unsigned char *image, unsigned long size){
	unsigned long i = 0;

	for (i = 0; i < size; i++)
		h_act[image[i]] += 1;
}

//Calculate minimum between a and b
int minimum(unsigned int a, unsigned int b){
	if(a < b)
		return a;
	else
		return b;
}
